<template>
    <v-card elevation="10">
        <v-card-title class="cyan darken-4">
            <v-row justify="center">
                <span class="display-1 font-weight-light white--text">Create Plan</span>
            </v-row>
        </v-card-title>
        <v-card-text class="text-left pa-3">
            <response-alert v-bind:error="error" v-bind:success="success"></response-alert>
            <v-form ref="createForm" lazy-validation>
                <v-text-field
                        v-model="planForm.title"
                        :rules="rule.title"
                        label="Title"
                        required
                ></v-text-field>
                <v-text-field
                        v-model="planForm.scale"
                        :rules="rule.scale"
                        hint="How many days?"
                        label="Scale"
                        required
                ></v-text-field>
            </v-form>
        </v-card-text>
        <v-card-actions>
            <v-btn class="cyan darken-4 white--text" block @click="createPlan">Create</v-btn>
        </v-card-actions>
    </v-card>
</template>

<script>
    import ResponseAlert from "./ResponseAlert";

    export default {
        name: "PlanCreateForm",
        components: {ResponseAlert},
        data() {
            return {
                rule: {
                    title: [
                        v => !!v || 'Title is required',
                    ],
                    scale: [
                        v => !!v || 'Scale is required',
                        v => Number.isInteger(Number(v)) || 'It should be numeric',
                    ],
                },
                planForm: {
                    title: '',
                    scale: '',
                },
                error: "",
                success: ""
            }
        },
        methods: {
            createPlan() {
                if (this.$refs.createForm.validate()) {
                    this.changeLoading()
                    this.$store.dispatch('createPlan', this.planForm).then(() => {
                        this.changeLoading()
                        this.successResponse("Plan Create Success")
                    }).catch(() => {
                        this.errorResponse("Error occur")
                    }).finally(() => {
                        this.changeLoading()
                    })
                }
            },
            errorResponse(error) {
                this.error = error
            },
            successResponse(success) {
                this.success = success
            },
            changeLoading() {
                this.$emit('isLoading')
            }
        }
    }
</script>

<style scoped>

</style>